#include "cenario.h"

CCenario::CCenario(volatile int *novoClock)
{
	valoresMatriz[0] = 3;
	valoresMatriz[1] = 12;
	valoresMatriz[2] = 9;
	valoresMatriz[3] = 10;
	valoresMatriz[4] = 6;
	valoresMatriz[5] = 5;
	valoresMatriz[6] = 15;
	valoresMatriz[7] = 0;
	//valoresMatriz = {3, 12, 9, 10, 6, 5, 15, 0};

    gClock = novoClock;
    trilhoAtual = 0;
	tempoMontagem = 300;
    BITMAP *tileset = load_bmp("res\\tileset.bmp", NULL);
    for (int i = 0; i < 8; i++)
    {
        tiles[i] = create_bitmap(TAMANHO_TILE_W, TAMANHO_TILE_H);
        blit(tileset, tiles[i], i * TAMANHO_TILE_W, 0, 0, 0, TAMANHO_TILE_W, TAMANHO_TILE_H);
    }
	buffer = create_bitmap(TAMANHO_TILE_W * TILES_HORIZONTAL, TAMANHO_TILE_H * TILES_VERTICAL);
    img_inicio = create_bitmap(32, 32);
    img_final = create_bitmap(32, 32);
    img_trem = create_bitmap(32, 32);
    blit(tileset, img_final, 0, TAMANHO_TILE_H, 0, 0, TAMANHO_TILE_W, TAMANHO_TILE_H);
    blit(tileset, img_inicio, TAMANHO_TILE_W, TAMANHO_TILE_H, 0, 0, TAMANHO_TILE_W, TAMANHO_TILE_H);
    blit(tileset, img_trem, 2 * TAMANHO_TILE_W, TAMANHO_TILE_H, 0, 0, TAMANHO_TILE_W, TAMANHO_TILE_H);
}



CCenario::~CCenario()
{
    destroy_bitmap(buffer);
    destroy_bitmap(img_trem);
    destroy_bitmap(img_final);
    destroy_bitmap(img_inicio);
    for (int i = 0; i < 7; i++)
        destroy_bitmap(tiles[i]);
}



void CCenario::PoeTrilho(int linha, int coluna)
{
	// se a coordenada for diferente de inicio && diferente de final
	if ((linha != trem->inicial.y || coluna != trem->inicial.x))
		matriz[linha][coluna] = valoresMatriz[trilhoAtual];
}



void CCenario::MudaTrilho()
{
	trilhoAtual++;
	if (trilhoAtual == 8)
		trilhoAtual = 0;
}



void CCenario::Init()
{
	trem = new CTrem;
	for (int linha = 0; linha < TILES_VERTICAL; linha++)
	    for (int coluna = 0; coluna < TILES_HORIZONTAL; coluna++)
	        matriz[linha][coluna] = 7;
    do
    {
        trem->atual.x = rand() % TILES_HORIZONTAL;
        trem->atual.y = rand() % TILES_VERTICAL;
        trem->final.x = rand() % TILES_HORIZONTAL;
        trem->final.y = rand() % TILES_VERTICAL;

    } while (trem->inicial.x == trem->final.x && trem->inicial.y == trem->final.y);
	tempoInicial = *gClock;
}


BITMAP *CCenario::Draw()
{
	for (int linha = 0; linha < TILES_VERTICAL; linha ++)
	    for (int coluna = 0; coluna < TILES_HORIZONTAL; coluna ++)
	        draw_sprite(buffer, tiles[matriz[linha][coluna]], coluna * TAMANHO_TILE_W, linha * TAMANHO_TILE_H);

	// DESENHAR A POSIO INICIAL E FINAL
	draw_sprite(buffer, img_trem, trem->atual.x * 32, trem->atual.y * 32);
	draw_sprite(buffer, img_final, trem->final.x * 32, trem->final.y * 32);

	return (buffer);
}


int CCenario::TempoRestanteMontagem()
{
	return(tempoMontagem - ((*gClock) - tempoInicial));
}


void CCenario::AtualizaPosicaoTrem()
{
	switch(trem->direcao)
	{
		case CIMA: 	//para cima
			if ((matriz[trem->atual.y][trem->atual.x] & 1) && (matriz[trem->atual.y - 1][trem->atual.x] & 2))
				trem->atual.y--;
			break;

		case BAIXO: 	//para baixo
			if ((matriz[trem->atual.y][trem->atual.x] & 2) && (matriz[trem->atual.y + 1][trem->atual.x] & 1))
				trem->atual.y++;
		    break;

		case ESQUERDA: 	//para esquerda
			if ((matriz[trem->atual.y][trem->atual.x] & 1) && (matriz[trem->atual.y - 1][trem->atual.x] & 2))
				trem->atual.x++;
		    break;

		case DIREITA: 	//para direita
			if ((matriz[trem->atual.y][trem->atual.x] & 1) && (matriz[trem->atual.y - 1][trem->atual.x] & 2))
				trem->atual.x--;
		    break;
	}
}
