#ifndef TINS_CENARIO
#define TINS_CENARIO

#include <allegro.h>
#include <iostream>
#include "trem.h"

#define TILES_HORIZONTAL   15
#define TILES_VERTICAL     15

#define TAMANHO_TILE_W     32
#define TAMANHO_TILE_H     32

class CCenario
{
private:
    volatile int *gClock;
	BITMAP *buffer;

public:
	CTrem *trem;
	int valoresMatriz[8];
    int matriz[TILES_VERTICAL][TILES_HORIZONTAL];
    int trilhoAtual;                    //  o trilho que est ativado no cursor
    BITMAP *tiles[8];                   // Esse vetor armazena as imagens
    BITMAP *img_inicio, *img_final, *img_trem;
    volatile int tempoInicial;                  // horrio que essa classe foi inicializada
    volatile int tempoMontagem;                 // o tempo mximo que o usurio tem para montar o trilho

	CCenario(volatile int*);
	~CCenario();
	void Init();    				    // Zera matriz e randomiza as posies inicial e final
	void PoeTrilho(int, int);  			// Coloca trilho
	void MudaTrilho();                  // Muda o trilho que est o cursor
	int TempoRestanteMontagem();
	BITMAP *Draw();                     // Desenha a matriz no buffer
	void AtualizaPosicaoTrem();
};


#endif //TINS_CENARIO
