// TINS'06
// Heitor, Rafael e Ricardo

#define GAME_RESOLUTION_W   640
#define GAME_RESOLUTION_H   480
#define GAME_COLOR_DEPTH    16
//#define GFX_MODE            GFX_AUTODETECT_WINDOWED



#include <allegro.h>
#include "error.h"		// error reporting
#include "kernel.h"	// main game loop
#include "menu.h"       // menu principal
#include <time.h>
#include <cstdio>


// Program entry point
int main(int argc, char *argv[])
{
	allegro_init();
	set_uformat(U_ASCII);	// Permite usar acentos da lngua portuguesa.
	srand(time(NULL));		// init seed random numbers

	if (install_timer())
		raise_error("main() : can't install timer driver");

	if (install_keyboard())
		raise_error("main() : can't install keyboard driver");

	if (install_mouse() < 0)
		raise_error("main() : can't install mouse driver");
/*
	if (install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, NULL))
        raise_error("install_sound() failed.\n'%s'\n", allegro_error);
*/
	set_color_depth(GAME_COLOR_DEPTH);
	if (set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, GAME_RESOLUTION_W, GAME_RESOLUTION_H, 0, 0))
		raise_error("main() : I can't set the graphics mode");





	//----------------------------------------
	//          Aqui comea o menu
	//----------------------------------------

	CMenu *menuPrincipal = new CMenu;
	menuPrincipal->Init();
	menuPrincipal->Draw();
	int tecla = 0;
	bool sair = false;
	while (!sair)
	{
		while(!keypressed());
		while(keypressed())
			tecla = readkey();
		if (tecla >> 8 == KEY_ENTER || tecla >> 8 == KEY_ENTER_PAD)
		{
			switch(menuPrincipal->focus)
			{
			case 0: // jogar
				gkernel_init(); // start the game kernel and main game loop (located at kernel.cpp)
				menuPrincipal->Draw();
				break;
			case 1:	// options
				break;
			case 2: // sair
				sair = true;
				break;
			}
		}
		if (tecla >> 8 == KEY_UP)
		{
			menuPrincipal->FocusUp();
			menuPrincipal->Draw();
		}
		if (tecla >> 8 == KEY_DOWN)
		{
			menuPrincipal->FocusDown();
			menuPrincipal->Draw();
		}
	}
	delete menuPrincipal;
	allegro_exit();
	return 0;
}
END_OF_MAIN()
